#include "slick!.h"
#include "menueng.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

char field_data[10][81];

int far scankey(ME_MENU far *m);

ME_COLORS colors = {
	0x0f,	/* normal */
	0x0a,	/* highlited char */
	0x4f,	/* cursor bar */
	0x4a,	/* hilited character in cursor bar */
	0x04,	/* disabled item */
	0x40,	/* cursor bar on disabled item */
};

ME_COLORS entrycolors = {
	0x24,	/* normal */
	0x2f,	/* highlited char */
	0x4f,	/* cursor bar */
	0x4a,	/* hilited character in cursor bar */
	0x04,	/* disabled item */
	0x40,	/* cursor bar on disabled item */
};
/*
** Write help message.
*/
void far helpout(ME_MENU far *m)
{
	_vputscp(0,_videocblk.rows-1,m->items[m->def-1].help,0x07,
				_videocblk.cols);
}

/*
** Main menu startup - draw desktop.
*/
int far mainstart(ME_MENU far *m,int x1,int y1,int x2,int y2)
{
	_videoparm();
	x1=x1+y1+x2+y2+m->def;
	x1=makewnd(0,0,_videocblk.cols-1,_videocblk.rows-1,"      ",
		0x0707,80);
	if (x1)
		cursoroff();	/* hide cursor if succeeded */
	return x1;
}

/*
** Startup/cleanup for menus.
*/
int far menustart(ME_MENU far *m,int x1,int y1,int x2,int y2)
{
	m->def+=0;
	return makewnd(x1-1,y1-1,x2+1,y2+1,DOUBLEFRAME,0x0f0f,80);
}

int far menuclean(ME_MENU far *m)
{
	m->def+=0;
	return closewnd();
}

/*
** This function will be called from pulldown.
*/
void far demofunc(ME_MENU far *m)
{
char s[80];
	sprintf(s,"You chose the \"%s\" from the menu",m->items[m->def-1].text);
	statwnd(s,FATFRAME,0x0f0f);
	scankey(m);
	closewnd();
}

unsigned int far cdecl entryscan(int ins)
{
	_CX=(ins)?_videocblk.scan-1:((_videocblk.scan-2)<<8)|(_videocblk.scan-1);
	_AH=1;
	__int__(0x10);
	return waitkey();
}

void far entryfunc(ME_MENU far *m)
{
unsigned int i;
unsigned int oldcur;
	i=m->def-1;
	oldcur=_getcursize();
	_editline(m->items[i].x,m->items[i].y,0x4f20,m->items[i].text,
		m->items[i].len,&i,entryscan);
	_setcursize(oldcur);
	if (m->def<m->count)
		m->def++;
	else
		m->def=0;
}

ME_ITEMS mixed_img [] = {
	{ 10, 7, 10,ME_IT_FUNC,0, -1,0,field_data[0],entryfunc,""},
	{ 10, 8, 40,ME_IT_FUNC,0, -1,0,field_data[1],entryfunc,""},
	{ 10, 9, 23,ME_IT_FUNC,0, -1,0,field_data[2],entryfunc,""},
	{ 10, 10,13,ME_IT_FUNC,0, -1,0,field_data[3],entryfunc,""},
	{ 10, 11,65,ME_IT_FUNC,0, -1,0,field_data[4],entryfunc,""},
	{ 10, 13,11,ME_IT_NORM,0,  0,0,"Go back",NULL,""},

};

ME_MENU mixed= { 6,1,ME_S_MOVE_UP|ME_S_MOVE_DN,
			&entrycolors,mixed_img,helpout,
				menustart,menuclean,NULL,scankey,NULL };

ME_ITEMS pull_img [] = {
	{ 1, 2,20,ME_IT_FUNC,2, 0,0,"First",demofunc,"This will call the function"},
	{ 1, 3,20,ME_IT_FUNC,2, 0,0,"Second",demofunc,"This will call the function also"},
	{ 1, 4,20,ME_IT_FUNC,2, 0,0,"Third",demofunc,"And this calls a function"},
	{ 1, 5,20,ME_IT_DOOR,2, 0,0,"Pulldown",&mixed,"This is a mixed layout menu"},
	{ 1, 6,20,ME_IT_NORM,2, 0,0,"Out",NULL,"This will return to main menu"},

};

ME_MENU pull= { 5,1,ME_S_MOVE_UP|ME_S_MOVE_DN|ME_S_LTRT_QT,
			&colors,pull_img,helpout,
				menustart,menuclean,NULL,scankey,NULL };

/*
** Main menu image & structure.
*/
ME_ITEMS main_img [] = {
	{ 0, 0,14,ME_IT_DOOR,1, 0,0,			"Show me more",&pull,"More choices in here"},
	{14, 0,15,ME_IT_FUNC|ME_IT_DIS,1, 0,0,	"Disabled item",NULL,"Second item"},
	{29, 0, 6,ME_IT_NORM,1, 0,0,			"Quit",NULL,"This is the way out"},
};


ME_MENU mainmenu={ 3,1,ME_S_MOVE_LT|ME_S_MOVE_RT|ME_S_DNEQUCR,
			&colors,main_img,helpout,
				mainstart,NULL,NULL,scankey,NULL };

/*
** Wait for user response.
**
** This is demonstration what we can do in here -
** this function filters out ESCapes pressed while in main menu.
*/
int far scankey(ME_MENU far *m)
{
int key;
char s[40];
	sprintf(s,"WND = %04X:%04X",(unsigned int)((long)_curntwnd>>16),
		(unsigned int)_curntwnd);
	_vputs(65,0,s,0x0f);
	if (testkey())		/* ignore any pending keystrokes */
		waitkey();		/* just in case... */
	_mousepress(LEFT,&key,&key,&key);	/* ingore pending presses */
	do {
		key=cuakey(m);
	} while (key==ME_ESC_KEY && m==&mainmenu);	/* filter ESCapes */
	return key;			/* return the key */
}

/*
** This is general cleanup function -
**
** We will release all memory and interrupt vectors,
** this is also a right place to deinitialize mouse driver.
*/
void cleanup(void)
{
	while (closewnd());			/* close all windows */
	_mousedeinit();
}

/*
** Main's body is real simple now - just set up everything and
** let the menu engine do the job.
*/
void main(void)
{
	atexit(cleanup);		/* first set up clenup function */
	_mouseinit(STDMOUSE);
	menueng(ME_MAKE,&mainmenu);
	exit(0);
}
