/*--- STARDUST.C ----------------------------------------------

	Demonstrates usage of timer, video control structure and
	pseudo-random generator.

	(c) by MacSoft 1991
*/

#include "slick!.h"
#include <stdlib.h>
#include <dos.h>

typedef struct {
	int x,y,		/* coordinates */
		age,		/* age of the star */
		shown;		/* last age shown */
} STAR;

STAR GALAXY[40];	/* galaxy is made of stars */
unsigned int ticker[2];
unsigned char *image=" *";

void showstar(int star);
void createstar(void);

/*
** This is timer event handler, ignores everithing except channel 0
*/
void far event(int channel)
{
int i;
	if (channel!=0)
		return;
	for (i=0;i<40;i++) {
		if (GALAXY[i].age)
			if (_myrand() & 5)
				GALAXY[i].age--;
	}
	ticker[0]=5;
}

/*
** Create new star
*/
void createstar(void)
{
int i;
	for (i=0;i<40;i++) {
		if (GALAXY[i].age==0)
			break;
	}
	if (i==40)
		return;
	showstar(i);
	GALAXY[i].x=(unsigned)_myrand()%_videocblk.cols;
	GALAXY[i].y=(unsigned)_myrand()%_videocblk.rows;
	GALAXY[i].age=_myrand()&7;
	GALAXY[i].shown=-1;
	showstar(i);
}

/*
** Show star
*/
void showstar(int i)
{
	if (GALAXY[i].age!=GALAXY[i].shown) {
		GALAXY[i].shown=GALAXY[i].age;
		_vputc(GALAXY[i].x,GALAXY[i].y,image[GALAXY[i].age]|0x0f00);
	}		
}

void interrupt newbreak(void)
{
}

void interrupt (*oldbreak)(void);

void cleanup(void)
{
	_deinittimer();
	while(closewnd());
	setvect(0x1b,oldbreak);
}


void main(void)
{
int i;
	oldbreak=getvect(0x1b);
	setvect(0x1b,newbreak);
	atexit(cleanup);
	_videoparm();
	makewnd(0,0,_videocblk.cols-1,_videocblk.rows-1,"         ",0x0707,80);
	cursoroff();
	for (i=0;i<40;i++)
		createstar();
	_inittimer(2,ticker);
	_eventtimer(event);
	ticker[0]=5;
	while (!testkey()) {
		_myrand();
		for (i=0;i<40;i++)
			showstar(i);
		createstar();
	}
	waitkey();
}

